// constcast1.cpp
// Example for usage of const_cast<> operator
// M. Schukat, 2002
// Based on:
//    Ammeraal, L. (2000) C++ for Programmers, 3rd Ed., Chichester: Wiley,
//    p. 124.

// Header files
#include <iostream.h>


// First function maxval() as defined previously.
int &maxval(int &x, int &y)
{
	if (x > y)
	{
		return x;
	}
	else
	{
		return y;
	}
}


// Second function maxval(). It deals with const arguments
int &maxval(const int &x, const int &y)
{
	// Use const_cast to convert const int into int, otherwise references do not work.
	return maxval(const_cast<int &>(x), const_cast<int &>(y));
}


// main() program
int main(void)
{
	int a = 5, b = 7, c;
	const int ca = 3, cb = 6;

	maxval(a, b) = 0; // a = 5, b = 0

	c = maxval(ca, cb); // c = cb;

	return 0;
}

