// List_s.h
// Example code for deep copy using copy constructor and overloaded "=" operator
// M. Schukat, 2002
 
// Declaration of structure for element:
struct DoubElem
{	
	double element;
	DoubElem* next;
};


// Declaration of class for set:
class DoubSet
{
public:
	// Constructor
	DoubSet(void) 
	{
		number = 0; 
	 	start  = 0;
	}

	// Test if list is empty
	bool Empty(void) const
	{
		return (number == 0);
	}

	// Test if element is in list
	bool IsElement(double x) const;
	
	// Insert element
	bool Insert(double x);
	
	// Print list of elements of list
	void Content(void) const;

	// All elements of list are incremented
	void IncrementAllElements(void);

	// Destructor
	~DoubSet(void);

	// NEW: Prototype for copy constructor
	DoubSet(const DoubSet &m);

	// NEW: Prototype for new "=" operator
	void operator=(const DoubSet& m);

private:
	int number;
	DoubElem* start;
};

