// friend1.cpp
// Implementation of a friend function
// M. Schukat, 2002


// Include header files
#include <iostream.h>
#include <stdlib.h>


// Class definition for RandomGenerator
class RandomGenerator
{
private:
	int v1, v2;

public:
	// Constructor
	RandomGenerator(void) : v1(0), v2(0) {}

	// Function to return random value
	int GetRandom(void)
	{
		v1 = rand();
		v2 = rand();

		return v1 - v2;
	}

	// Prototype of friend function
	// Important:We need to pass a reference to the object.
	friend void Debug(RandomGenerator* t);
};


// Function prototype of friend function.
// Important:We need to pass a reference to the object.
void Debug(RandomGenerator* t);


// Main function
int main(void)
{
	RandomGenerator t1;

	cout << "The random value is " << t1.GetRandom() << endl;

	// Call of friend function
	// Important:We need to pass a reference to the object, e.g,
	// since Debug() is not a member function of the class
	// RandomGenerator, we CANNOT write t1.Debug()
	Debug(&t1);

	return 0;
}


// Implementation of void Debug(RandomGenerator* t)
void Debug(RandomGenerator* t)
{
	cout << "v1 = " << t->v1 << "   v2 = " << t->v2 << endl;
}
