// Inheritance1_extension.cpp
// Example for inheritance used for extension
// M. Schukat, 2002

// include header files
#include <iostream.h>
#include <string.h>


// Parent class Muppet
class Muppet
{
protected:
	// Both attributes are "protected" and can be accessed by a subclass.
	char greeting[20];
	char name[20];

public:
	// Constructor
	Muppet(void)
	{
		strcpy(greeting, "Nice to meet you.");
	}

	// member function assignName
	void assignName(char *s)
	{
		strcpy(name, s);
	}
	
	// Member function greet
	void greet(void)
	{
		cout << "This is " << name << ". He says: " << greeting << endl << endl;
	}
};


// Derived class VeryGrumpyMuppet
class VeryGrumpyMuppet : public Muppet
{
public:
	// New constructor
	VeryGrumpyMuppet(void)
	{
		strcpy(greeting, "Go away!!");
	}

	// New method cuddle(), which is an extension of base class Muppet
	void cuddle(void)
	{
		cout << "This is " << name << ". He says: "<< "Don't cuddle me!" << endl << endl;
	}
};

// Main function
int main(void)
{
	Muppet kermit;
	VeryGrumpyMuppet oscar;

	kermit.assignName("Kermit the Frog");
	oscar.assignName("Oscar the Grouch");

	kermit.greet();
	oscar.greet();
	
	// Call od member function cuddle().
	// Remark: kermit.cuddle() does NOT work.
	oscar.cuddle();

	return 0;
}
